#!/usr/bin/env python

import sys
import os

if len(sys.argv) >= 2:
	if sys.argv[1] == 'swig':
		print "running swig"
		output = os.system('swig -python -shadow main.swg')
		if output:
			print output
		sys.exit(0)
	elif sys.argv[1] == 'install' or sys.argv[1] == 'bdist_wininst':
		# hack, for some reason _verse.so/dll doesn't get copied to build/
		os.system('cp -f _verse.* build/lib\.*/')

from distutils.core import setup, Extension

verse = Extension('_verse', ['main_wrap.c'],
				  libraries=['verse'])

setup(name = 'pyverse', version='r6p1', 
      description = 'Python bindings for Verse',
	  long_description = 'Verse is a real-time network protocol for 3D graphics that allows multiple applications to work whit the same data.',
	  author = 'pyverse project',
	  author_email = '-',
	  license = 'FreeBSD License',
	  platforms = ['Any'],
	  url = 'http://projects.blender.org/projects/pyverse/',
	  py_modules = ['verse'],
      ext_modules = [verse])

